package com.sun.java.swing.plaf.windows;

import javax.swing.ButtonModel;
import java.awt.Rectangle;
import java.awt.Color;
import java.awt.Graphics;
import javax.swing.plaf.ComponentUI;
import javax.swing.JComponent;
import javax.swing.JMenuItem;
import javax.swing.plaf.basic.BasicRadioButtonMenuItemUI;

public class WindowsRadioButtonMenuItemUI extends BasicRadioButtonMenuItemUI
{
    final WindowsMenuItemUIAccessor accessor;
    
    public WindowsRadioButtonMenuItemUI() {
        this.accessor = new WindowsMenuItemUIAccessor() {
            @Override
            public JMenuItem getMenuItem() {
                return WindowsRadioButtonMenuItemUI.this.menuItem;
            }
            
            @Override
            public TMSchema.State getState(JMenuItem menuItem) {
                return WindowsMenuItemUI.getState(this, menuItem);
            }
            
            @Override
            public TMSchema.Part getPart(JMenuItem menuItem) {
                return WindowsMenuItemUI.getPart(this, menuItem);
            }
        };
    }
    
    public static ComponentUI createUI(JComponent component) {
        return new WindowsRadioButtonMenuItemUI();
    }
    
    @Override
    protected void paintBackground(Graphics g, JMenuItem menuItem, Color bgColor) {
        if (WindowsMenuItemUI.isVistaPainting()) {
            WindowsMenuItemUI.paintBackground(this.accessor, g, menuItem, bgColor);
            return;
        }
        super.paintBackground(g, menuItem, bgColor);
        return;
    }
    
    @Override
    protected void paintText(Graphics graphics, JMenuItem menuItem, Rectangle rectangle, String s) {
        if (WindowsMenuItemUI.isVistaPainting()) {
            WindowsMenuItemUI.paintText(this.accessor, graphics, menuItem, rectangle, s);
            return;
        }
        ButtonModel model = menuItem.getModel();
        Color color = graphics.getColor();
        if (model.isEnabled() && model.isArmed()) {
            graphics.setColor(this.selectionForeground);
        }
        WindowsGraphicsUtils.paintText(graphics, menuItem, rectangle, s, 0);
        graphics.setColor(color);
        return;
    }
}
